#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <stdbool.h>


#define M 100

/* L'algo du crible, cf TD4 */
void crible(bool t[M], int m){
  // on fait le crible jusqu'à m compris
  // init avec false, false, (true)*
  t[0]=false;
  t[1]=false;
  int i;
  int mult;
  for (i = 2; i<=m; i++){
    t[i] = true; // un entier est premier jusqu'à preuve du contraire
  }
  // on parcourt tous les candidats à être premier, jusqu'à "la racine" de m
  for (i=2; i*i <= m  ; i++){
    // on "raye" les multiples de i
    mult = 2*i;
    while (mult <=m) {
      t[mult] = false;
      mult = mult + i;
    }
  }
}

/* fonction d'impression*/
void print_primes_until(int m){
  bool t[M];
  int cpt=0; // uniquement là pour afficher 10 premiers par ligne
  crible(t, m);
  for (int i=2; i<m; i++){
    if (t[i]) {cpt ++; printf("%d,", i);}
    if (cpt%10 ==9) printf("\n");
  }
  printf("\n");
}



int main(){
  
  print_primes_until(25);  
  
  return 0;
}
