/*Source code from Laure Gonnord*/
// Quelques fonctions de tableaux faites en cours/TD/TP

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>

// Déclaration de constante symbolique pour les tailles de tableau
// (on pourrait utiliser un autre nom que N)
#define N 15

void init_tab(int t[N], int el){
  /*Initialise toutes les cellules du  tableau t avec l'élément el*/
  for (int i =0; i<N ; i++){
    t[i] = el;
  }
}


void init_tab_random(int t[N], int max){
  /*Initialise toutes les cellules du  tableau t
    avec un élément tiré au hasard entre 0 et max non compris*/
  for (int i =0; i<N ; i++){
    t[i] = random()%max;
  }
}



void print_tab(int t[N]){
  /*Impression des cellules du tableau*/
  for (int i=0; i<N; i++){
    printf("%d,", t[i]);
    if (i%10==9) printf("\n"); //saut de ligne au bout de 10 cellules
  }
  printf("\n"); // saut de ligne à la fin.
}


bool is_in_array(int t[N], int el){
  /*Recherche l'élément el dans le tableau t*/
  for (int i=0; i<N; i++){
    if (t[i]==el) return true;
  }
  return false;
}

int main(){
  int tab[N]; // déclaration

  srand(time(NULL)); // initialisation du générateur de nombres aléatoires.
  
  init_tab(tab, 42); // initialisation
  print_tab(tab); // impression

  init_tab_random(tab, 10); // initialisation randomisée
  print_tab(tab); // impression
  
  
  if (is_in_array(tab, 5))
    // cherche 5 dans le tableau. Il est possible qu'il faille lancer
    // plusieurs fois le programme pour le trouver 
    printf("found 5!\n");
  else
    printf("5 not found\n");

  return 0;
}
