/*Source code from Laure Gonnord*/
/* Algorithmes: tableaux triés */

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <stdbool.h>

#define N 10


/* fonction d'impression sur le terminal*/
void visu_tab(int t[N])
{
  int i;
  printf("[");
  for (i=0;i<N-1;i=i+1)
    {
      printf(" %d ,",t[i]);
      if (i%10 == 9) 
        {printf("\n");}
    }
  printf(" %d ]\n\n",t[N-1]);
}


/*initialisation du generateur de nombres aléatoires*/
void initialise_rand()
{
  srand(time(NULL));  
}

/*tire un entier au hasard entre inf et sup */
int hasard(int inf, int sup)
{
  int rando = rand();
  return (inf + (rando % (sup - inf +1)));
}

/* initialise un tableau trié*/
void init_tab_random_sorted(int t[N]){
  int temp;
  t[0]=hasard(0,100);
  for (int i=1; i<N; i++){
    temp = hasard(0,100+50*i);
    while (temp < t[i-1]){
      temp = hasard(0,100+50*i);
    }
    t[i] = temp;
  }
}

/* fonction d'impression d'un booléen*/
void print_bool(bool b){
  if (b) printf("oui\n"); else printf("non\n");
}



/* est-ce que le tableau est trié ?*/
bool is_sorted(int t[N]){
  for (int i=0;i<N-1;i++){
    if (t[i] > t[i+1]) return false;
  }
  return true;
}

/* Recherche dichotomique récursive, fonction auxiliaire */
// (cherche l'élément entre left compris et right compris)
bool find_in_sortedtab_aux(int t[N], int el, int left, int right){
  int mid;
  if (right < left) return false;
  else {
    mid = (left+right)/2;

    if (t[mid]==el) return true;
    else
      if (t[mid] < el) // recherche à droite
	find_in_sortedtab_aux(t, el, mid+1, right);
      else
	find_in_sortedtab_aux(t, el, left, mid-1);
  }
  return false; // jamais atteint mais le compilateur chouine quand même.
}

/* recherche dichotomique, fonction principale*/
bool find_in_sortedtab(int t[N], int el){
  return find_in_sortedtab_aux(t, el, 0, N-1);
}

int main(){
  initialise_rand();
  int t2[N];

  init_tab_random_sorted(t2);  
  visu_tab(t2);
  print_bool(is_sorted(t2));

  int int_to_find;
  printf("Donnez-moi un élément à chercher svp\n");
  scanf("%d", &int_to_find);
  print_bool(find_in_sortedtab(t2,int_to_find));

  
  return 0;
}
