/*Source code from Laure Gonnord*/
/* Algorithmes: tris de tableaux d'entiers */

// Notez le changement dans le passage de paramètre tableau:
// Tableau statique "de n'importe quelle taille"
// et un paramètre qui propage l'information de la taille.

#include <stdio.h>

/* fonction d'impression sur le terminal*/
void visu_tab(int t[], int size)
{
  int i;
  printf("[");
  for (i=0;i<size-1;i=i+1)
    {
      printf(" %d ,",t[i]);
      if (i%10 == 9) 
        {printf("\n");}
    }
  printf(" %d ]\n\n",t[size-1]);
}



/*la fonction permute*/

void permute(int t[], int size, int i, int j){
  int temp;
  //  printf("permute indices %d et %d\n",i, j);
  if (0<=i && i<size && 0<=j && j<size){
    temp = t[i];
    t[i] = t[j];
    t[j] = temp;
  }
}

/*procedure de tri bulle*/
void tri_bulle2(int t[],int size)
{
  int i,j;

  for (i=0;i<=size-2;i++)
    {
      for (j=size-1;j>=i+1;j--)
	{
	  if (t[j]<t[j-1]) {permute(t,size,j,j-1);}
	}
    }
}

/*tri insertion*/
void tri_insertion(int t[], int size)
{
  int j,k;
  for (k=1;k<=size-1;k++)
    {
    j = k;
    while ((t[j-1]>t[j]) && (j>1))
      {
	permute(t,size,j,j-1);
	j = j-1;
      }
    }
}

/*tri selection*/
void tri_selection(int t[], int size)
{
  int  max_tmp,indice_max,k,i;
  for (k=size-1;k>=1;k--)
    {
      max_tmp = t[0];
      indice_max = 0;
      for (i=1;i<=k;i++)
	{
	if (t[i]>max_tmp)
	  {
	    max_tmp = t[i];
	    indice_max = i;
	  };
	}
      permute(t,size,indice_max,k);
    }
}

/*fusion*/
void fusion(int t[], int size, int deb,int milieu, int fin)
{
  int cpt2=milieu+1;
  int cpt1=deb;
  int i;
  int fus[size];

  for(i=0;i<=fin-deb;i++){
    if (cpt1<=milieu &&(t[cpt1]<=t[cpt2] || cpt2>fin)) 
      {
	fus[i]=t[cpt1];
	cpt1++;
      }
    else
      {
	fus[i]=t[cpt2];
	cpt2++;
      }
  }
  
  for(i=0;i<=fin-deb;i++){
    t[deb+i] = fus[i];
  }
  
  //fin fusion
}


/* Procédure auxiliaire de tri fusion (récursive)*/
void tri_fusion_aux(int t[], int size, int deb, int fin)
{

  int milieu;
  if (deb==fin-1)
    {
      if (t[deb]>t[fin])
	permute(t,size,deb,fin);	
    }
  else {if(deb<fin)
      {
	milieu = (deb+fin)/2; 
	tri_fusion_aux(t,size,deb,milieu);
	tri_fusion_aux(t,size,milieu+1,fin);
	fusion(t,size,deb,milieu,fin);
      }
  } // fin else
}

void tri_fusion(int tab[], int size){

  if (size > 1){
    tri_fusion_aux(tab, size, 0, size-1);
  }
}


// 2022 : je n'ai pas fait le tri rapide.

int main(void)
{

  int tab[8]={-1515,-15,5,-2235,115,0,1515,1};

  visu_tab(tab,8);
  tri_fusion(tab,8);  
  visu_tab(tab,8);

  return 0;

}



